#include <bits/stdc++.h>

using namespace std;
#define endl '\n'
#define ll long long
#define vi vector<ll>

void solve1(ll n, ll m, vector<vector<ll>> a) {
    ll sum = 0;
    vi strok(n), stolb(m);
    for (ll i = 0; i < n; i++) {
        for (ll j = 0; j < m; j++) {
            sum += a[i][j];
            strok[i] += a[i][j];
        }
    }
    ll s;
    cin >> s;
    for (ll i = 0; i < m; i++) {
        for (ll j = 0; j < n; j++) {
            stolb[i] += a[j][i];
        }
    }
    for (ll i = 0; i < (1 << 18); i++) {
        ll obs = 0;
        vi h, w;
        for (ll j = 0; j < 18; j++) {
            if (obs == -1) break;
            if (((i >> j) & 1) == 1) {
                ll fl = 0;
                if (j > 2 && j - 3 >= m) {
                    fl = 1;
                }
                if (j < 3 && j >= n) {
                    fl = 1;
                }
                ll val;
                if (j < 3 && j < n) {
                    val = strok[j];
                } else if (j > 2 && j - 3 < m) {
                    val = stolb[j - 3];
                }
                if (obs != -1 && !fl) {
                    obs += val;
                    if (j < 12 && j < n) {
                        h.push_back(j);
                    } else if (j - 3 < m) {
                        w.push_back(j - 3);
                    }
                }
                if (fl) {
                    obs = -1;
                }
            }
        }
        for (ll j: h) {
            for (ll u: w) {
                obs -= a[j][u];
            }
        }
        if (obs == sum - s) {
            cout << "YES" << endl;
            cout << h.size() + w.size() << endl;
            reverse(h.begin(), h.end());
            reverse(w.begin(), w.end());
            for (ll j: h) {
                cout << 1 << " " << j + 1 << endl;
            }
            for (ll j: w) {
                cout << 2 << " " << j + 1 << endl;
            }
            return;
        }
    }
    cout << "NO" << endl;
}

void solve2(ll n, ll m, vector<vector<ll>> a) {
    ll sum = 0;
    vi strok(n), stolb(m);
    for (ll i = 0; i < n; i++) {
        for (ll j = 0; j < m; j++) {
            sum += a[i][j];
            strok[i] += a[i][j];
        }
    }
    ll s;
    cin >> s;
    for (ll i = 0; i < m; i++) {
        for (ll j = 0; j < n; j++) {
            stolb[i] += a[j][i];
        }
    }
    for (ll i = 0; i < (1 << 24); i++) {
        ll obs = 0;
        vi h, w;
        bitset<25> b = i;
        for (ll j = b._Find_first(); j < 25; j = b._Find_next(j)) {
            ll fl = 0;
            if (j > 11 && j - 12 >= m) {
                fl = 1;
            }
            if (j < 12 && j >= n) {
                fl = 1;
            }
            ll val;
            if (j < 12 && j < n) {
                val = strok[j];
            } else if (j > 11 && j - 12 < m) {
                val = stolb[j - 12];
            }
            if (obs != -1 && !fl) {
                obs += val;
                if (j < 12 && j < n) {
                    h.push_back(j);
                } else if (j - 12 < m) {
                    w.push_back(j - 12);
                }
            }
            if (fl) {
                obs = -1;
            }
        }
        for (ll j: h) {
            for (ll u: w) {
                obs -= a[j][u];
            }
        }
        if (obs == sum - s) {
            cout << "YES" << endl;
            cout << h.size() + w.size() << endl;
            reverse(h.begin(), h.end());
            reverse(w.begin(), w.end());
            for (ll j: h) {
                cout << 1 << " " << j + 1 << endl;
            }
            for (ll j: w) {
                cout << 2 << " " << j + 1 << endl;
            }
            return;
        }
    }
    cout << "NO";
}

void solve3(ll n, ll m, vector<vector<ll>> a) {
    ll sum = 0;
    vi strok(n), stolb(m);
    for (ll i = 0; i < n; i++) {
        for (ll j = 0; j < m; j++) {
            sum += a[i][j];
            strok[i] += a[i][j];
        }
    }
    ll s;
    cin >> s;
    for (ll i = 0; i < m; i++) {
        for (ll j = 0; j < n; j++) {
            stolb[i] += a[j][i];
        }
    }


    const ll lim = 6 * 225 + 1;
    for (ll i = 0; i < (1 << n); i++) {
        ll obs = 0;

        vi gg;
        auto copy = stolb;
        for (ll j = 0; j < n; j++) {
            if (((i >> j) & 1) == 1) {
                gg.push_back(j);
                obs += strok[j];
            }
        }

        for (ll j = 0; j < m; j++) {
            for (ll u: gg) {
                copy[j] -= a[u][j];
            }
        }

        bitset<lim> b;
        b[0] = 1;
        vector<ll> p(lim);

        for (ll j = 0; j < m; j++) {
            auto c = b;
            b |= (b << copy[j]);
            c ^= b;
            for (ll u = c._Find_first(); u < lim; u = c._Find_next(u)) {
                p[u] = j;
            }
        }

        if (sum - s - obs >= 0 && b[sum - s - obs]) {
            cout << "YES" << endl;
            ll j = sum - s - obs;
            vi w;
            while (j != 0) {
                w.push_back(p[j]);
                j -= copy[p[j]];
            }
            cout << gg.size() + w.size() << endl;
            for (ll u: gg) {
                cout << 1 << " " << u + 1 << endl;
            }
            for (ll u: w) {
                cout << 2 << " " << u + 1 << endl;
            }
            return;
        }
    }
    cout << "NO";
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ll n, m;
    cin >> n >> m;
    ll fl = 0;
    vector<vector<ll>> a(n, vector<ll>(m));
    for (ll i = 0; i < n; i++) {
        ll sum = 0;
        for (ll j = 0; j < m; j++) {
            cin >> a[i][j];
            sum += a[i][j];
        }
        if (sum > i + 1) {
            fl = 1;
        }
    }
    if (fl == 0) {
        solve3(n, m, a);
    } else if (n <= 3) {
        solve1(n, m, a);
    } else if (n <= 10 && m <= 10) {
        solve2(n, m, a);
    } else {
        solve3(n, m, a);
    }
}