#include <bits/stdc++.h>

using namespace std;
#define pb push_back
#define endl '\n'
#define ll long long
#define vi vector<ll>

const ll N = 2e5, K = 22;

ll up[22][N];
vector<vector<ll>> g(N);
vi used(N), d(N), h(N), maxx(N);
ll mn = 0;

void dfs(ll v, ll p) {
    up[0][v] = p;

    for (ll i = 1; i < K; i++) {
        up[i][v] = up[i - 1][up[i - 1][v]];
    }

    used[v] = 1;
    ll fl = 0;
    for (ll to: g[v]) {
        if (used[to] == 0) {
            d[to] = d[v] + 1;
            maxx[to] = d[to];
            fl = 1;
            dfs(to, v);
            h[v] = max(h[v], h[to] + 1);
            maxx[v] = max(maxx[v], maxx[to]);
        }
    }
    if (!fl) {
        h[v] = 0;
        mn = max(mn, d[v]);
    }
}

ll LCA(ll v, ll to) {
    if (d[v] > d[to]) {
        swap(v, to);
    }
    for (ll i = K - 1; i >= 0; i--) {
        if (d[up[i][to]] >= d[v]) {
            to = up[i][to];
        }
    }

    if (v == to) {
        return v;
    }

    for (ll i = K - 1; i >= 0; i--) {
        if (up[i][to] != up[i][v]) {
            to = up[i][to];
            v = up[i][v];
        }
    }
    return up[0][v];
}

void dfs2(ll v, ll mx, ll pred) {

    //cout << mx << " " << pred << endl;
    if (up[0][v] != 0) {

        ll lca = LCA(v, pred);
        ll res1 = 1 + h[v];
        ll res2;
        if (lca == v || lca == mx) {
            res2 = d[v - 1];
        } else {
            res2 = max(mx, d[v] - d[lca] + d[pred] - d[lca]);
        }
        //ll res2 = max(mx, d[v] - d[lca] + d[pred] - d[lca]);
        ll res = max(res1, res2);
        if (res < mn) {
            mn = res;
        }
        //cout << mx << " " << pred << endl;
        //cout << res1 << " " << res2 << " " << v << endl;

    }

    used[v] = 1;
    set<pair<ll, ll>> ms;
    for (ll to: g[v]) {
        if (used[to] == 0) {
            ms.insert({maxx[to], to});
        }
    }

    ms.insert({0, 0});
    for (ll to: g[v]) {
        if (used[to] == 0) {
            ll mx2, pref2;
            ms.erase(ms.find({maxx[to], to}));

            auto it = --ms.end();
            mx2 = (*it).first, pref2 = (*it).second;
            if (mx2 > mx) {
                dfs2(to, mx2, pref2);
            } else {
                dfs2(to, mx, pred);
            }

            ms.insert({maxx[to], to});
        }
    }
}

void solve(ll n, ll k, ll t) {
    for (ll i = 0; i < n - 1; i++) {
        ll x, y;
        cin >> x >> y;
        x--, y--;
        g[x].pb(y);
        g[y].pb(x);
    }
//    d[0] = 0;
//    dfs(0, 0);
//    used.assign(n, 0);
//    dfs2(0, 0, 0);
//    cout << mn;
      ll dd  = n - 1;
      cout << max((dd +1)/ 2 + 1, (dd+1) / 2 - 1);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ll n, k, t;
    cin >> n >> k >> t;
    //solve(n, k, t);
}